/**
 * Die Klasse Binbaum ist die Grundstruktur eines geordneten Binrbaums
 * und hier zur Verwaltung von Usern eingesetzt wird.
 * Die Methoden die ein Objekt dieser Klasse anbietet, leiten den Aufruf an den
 * Wurzelknoten weiter, wenn der Baum nicht leer ist.
 * (Implementierung ohne Entwurfsmuster Kompositum)
 * 
 * @author Peter Brichzin
 * @version 24.5.24
 */
 class BinBaum
{
    /** Die Wurzel des Baums */
    private Knoten wurzel;

    /**
     * Konstruktor fr Objekte der Klasse Binbaum:
     * Ein leerer Baum wird erzeugt.
     */
    BinBaum()
    {
        wurzel = null;
    }

    /**
     * Fgt ein Datenelement sortiert in den geordneten Binrbaum ein, 
     * d.h. die Eigenschaft, dass der Baum geordnet ist bleibt bei jedem 
     * Einfgevorgang erhalten.
     * @param datenNeu neues Datenelement
     */
     void Einfgen(User datenNeu)
    {
        if(wurzel != null)
        {
            wurzel.Einfgen(datenNeu); 
        }
        else
        {
            wurzel = new Knoten(datenNeu);
        }
    }
}
