/**
 * Die Klasse User dient zur Speicherung von Usern
 * in einem Online-Shop.  
 * 
 * @author Peter Brichzin 
 * @version 23.5.24
 */

class User 
{
    /** id - Schlssel dieses Datenelements */    
    private int id;
    /**  Nachname  */  
    private String nachname;
    /**  Vorname  */  
    private String vorname;

    /**
     * Konstruktor fr Objekte der Klasse User
     *
     * @param idNeu Identifikationsnummer
     * @param nachnameNeu Nachname
     * @param vornameNeu Vorname
     */
    User(int idNeu, String nachnameNeu, String vornameNeu)
    {
        id = idNeu;
        nachname = nachnameNeu;
        vorname = vornameNeu;
    }

    /**
     * Gibt Information ber das Datenelement zu Kontrollzwecken
     * auf das Terminalfenster aus.
     */
    void InformationAusgeben()
    {
        System.out.println("Der User " + vorname + " " + nachname + " hat die Id " + id + ".");
    }

    /**
     * Vergleicht zwei Datenelemente auf Gleichheit.
     * @param dvergleich Datenelement mit dem das Objekt verglichen wird.
     * @return true, wenn die beiden Datenelemente gleichen Schlssel haben.
     * 
     * Hinweis: fr den lexikografischen Vergleich wird die Methode 
     * compareTo(String vergleichsZeichenkette) der Klasse String genutzt.
     * Das Ergebnis ist eine negative ganze Zahl, wenn das ausfhrende 
     * Zeichenketten-Objekt lexikografisch vor dem Eingabewert liegt. 
     * Das Ergebnis ist eine positive ganze Zahl, das ausfhrende 
     * Zeichenketten-Objekt lexikografisch hinter dem Eingabewert liegt.
     * Das Ergebnis ist 0, wenn die Zeichenketten gleich sind; 
     * 
     */
    boolean IstGleich(User dVergleich)
    {
        if(nachname.compareTo(dVergleich.NachnameGeben()) == 0)
        {
            return true;
        }
        else
        {
            return false;
        }       
    }

    /**
     * Vergleicht zwei Datenelemente bezglich der Ordnungsrelation.
     * @param vergleichselement Datenelement mit dem das Objekt verglichen wird.
     * @return true, wenn das aktuelle Element einen greren Schlssel 
     * hat, als das angegebene Vergleichselement.
     */
    boolean IstGrerAls(User dVergleich)
    {
        if(nachname.compareTo(dVergleich.NachnameGeben()) > 0)                                                                                                                                                                                                                                                            
        {
            return true;
        }
        else
        {
            return false;
        }       
    }

    /**
     * Vergleicht zwei Schlssel, die als Zeichenketten vorliegen, auf Gleichheit.
     * @param vergleichsSchlssel Schlssel  mit dem der Schlssel des Objekt verglichen wird.
     * @return true, wenn die beiden Schlssel gleich sind.
     */
    boolean SchlsselIstGleich(String vergleichsSchlssel)
    {
        if(nachname.compareTo(vergleichsSchlssel) == 0)                                                                                                                                                                                                                                                            
        {
            return true;
        }
        else
        {
            return false;
        }       
    }

    /**
     * Vergleicht zwei Schlssel, die als Zeichenketten vorliegen, bezglich der Ordnungsrelation.
     * @param vergleichsSchlssel Schlssel  mit dem der Schlssel des Objekt verglichen wird.
     * @return true, wenn das aktuelle Element einen gr&szlig;eren Schlssel 
     * hat, als das angegebene Vergleichselement.
     */
    boolean SchlsselIstGrerAls(String vergleichsSchlssel)
    {
        if(nachname.compareTo(vergleichsSchlssel) > 0)                                                                                                                                                                                                                                                            
        {
            return true;
        }
        else
        {
            return false;
        }      
    }

    /**
     * Geben-Methode zum Attribut nachname
     * @return      Nachname
     */
    String NachnameGeben()
    {
        return nachname;
    }

    /**
     * Geben-Methode zum Attribut vorname
     * @return      Vorname
     */
    String VornameGeben()
    {
        return vorname;
    }
}
